      subroutine forday(dtime,yrflag, iyear,iday,ihour)
      implicit none
c
      double precision dtime
      integer          yrflag, iyear,iday,ihour
c
c --- converts model day to "calendar" date (year,julian-day,hour).
c
      double precision dtim1,day
      integer          iyr,nleap
c
      if     (yrflag.eq.0) then
c ---   360 days per model year, starting Jan 16
        iyear =  int((dtime+15.001d0)/360.d0) + 1
        iday  =  mod( dtime+15.001d0 ,360.d0) + 1
        ihour = (mod( dtime+15.001d0 ,360.d0) + 1.d0 - iday)*24.d0
c
      elseif (yrflag.eq.1) then
c ---   366 days per model year, starting Jan 16
        iyear =  int((dtime+15.001d0)/366.d0) + 1
        iday  =  mod( dtime+15.001d0 ,366.d0) + 1
        ihour = (mod( dtime+15.001d0 ,366.d0) + 1.d0 - iday)*24.d0
c
      elseif (yrflag.eq.2) then
c ---   366 days per model year, starting Jan 01
        iyear =  int((dtime+ 0.001d0)/366.d0) + 1
        iday  =  mod( dtime+ 0.001d0 ,366.d0) + 1
        ihour = (mod( dtime+ 0.001d0 ,366.d0) + 1.d0 - iday)*24.d0
c
      elseif (yrflag.eq.3) then
c ---   model day is calendar days since 01/01/1901
        iyr   = (dtime-1.d0)/365.25d0
        nleap = iyr/4
        dtim1 = 365.d0*iyr + nleap + 1.d0
        day   = dtime - dtim1 + 1.d0
        if     (dtim1.gt.dtime) then
          iyr = iyr - 1
        elseif (day.ge.367.d0) then
          iyr = iyr + 1
        elseif (day.ge.366.d0 .and. mod(iyr,4).ne.3) then
          iyr = iyr + 1
        endif
        nleap = iyr/4
        dtim1 = 365.d0*iyr + nleap + 1.d0
c
        iyear =  1901 + iyr
        iday  =  dtime +0.01d0 - dtim1 + 1
        ihour = (dtime - dtim1 + 1.01d0 - iday)*24.d0
c
      else
        stop '(forday)'
      endif
      return
      end

      subroutine getdat_name(flnm, dtime,yrflag)
      use mod_za     ! HYCOM array I/O interface
c
      implicit none
c
      character        flnm*(*)
      double precision dtime
      integer          yrflag
c
c --- modify the archive filename for the specified model day.
c --- flnm is assumed to be of the form */archv_????_???_??.b.
c
      integer   iyear,iday,ihour,l
c
      call forday(dtime,yrflag, iyear,iday,ihour)
c
      l = len_trim(flnm)
      write(flnm(l-12:l-9),'(i4.4)') iyear
      write(flnm(l- 7:l-5),'(i3.3)') iday
      write(flnm(l- 3:l-2),'(i2.2)') ihour
      return
      end

      subroutine getdat_time(flnm, time,iexpt)
      use mod_za     ! HYCOM array I/O interface
c
      implicit none
c
      character        flnm*(*)
      double precision time
      integer          iexpt
c
c --- extract the model time (and iexpt) from an archive.
c
      character cline*80,cvarin*6
      integer   i,irec,l,ni,nstep
c
      data ni/14/
c
      l = len_trim(flnm)
      open (unit=ni,file=flnm(1:l-2)//'.b',form='formatted',
     &      status='old',action='read')
      do irec= 1,5
        read (ni,'(a)',end=6) cline
      enddo
      read( ni,*) iexpt,cvarin
      if (cvarin.ne.'iexpt ') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be iexpt '
        write(lp,*)
        call flush(lp)
        stop
      endif
      do irec= 1,16
        read (ni,'(a)',end=6) cline
      enddo
      i = index(cline,'=')
      read (cline(i+1:),*)  nstep,time
      close(unit=ni)
      return
c
c --- unexpected end of file
 6    continue
        write (lp,*) '***** 1 unexpected end of archive file *****'
        write (lp,*) flnm(1:l-2)//'.b'
        call flush(lp)
        stop '(e-o-f)'
      end

      subroutine getdat_archm(flnm,time, iexpt,yrflag, trcout,mxlflg)
      use mod_tracer  ! HYCOM post-processing tracer archive array interface
      use mod_za      ! HYCOM array I/O interface
c
      implicit none
c
      character        flnm*(*)
      double precision time
      integer          iexpt,yrflag
      logical          trcout  !ignored
      integer          mxlflg
c
c --- read model fields for floats.
c --- HYCOM 2.0 array I/O archive file.
c
      character cline*80
      character preambl(5)*79
      character cvarin*6
      real      hminb,hmaxb,thet
      integer   idmtst,irec,iversn,ios,jdmtst,l,layer,ni,nstep
c
      data ni/14/
c
      l = len_trim(flnm)
      open (unit=ni,file=flnm(1:l-2)//'.b',form='formatted',
     &      status='old',action='read')
      call zaiopf(flnm(1:l-2)//'.a','old', ni)
c
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      call flush(lp)
      read( ni,*) iversn,cvarin
      write(lp,*) cvarin,' = ',iversn
      if (cvarin.ne.'iversn') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                          ' but should be iversn'
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) iexpt,cvarin
      write(lp,*) cvarin,' = ',iexpt
      if (cvarin.ne.'iexpt ') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be iexpt '
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) yrflag,cvarin
      write(lp,*) cvarin,' = ',yrflag
      if (cvarin.ne.'yrflag') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be yrflag'
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) idmtst,cvarin
      write(lp,*) cvarin,' = ',idmtst
      if (cvarin.ne.'idm   ') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be idm   '
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) jdmtst,cvarin
      write(lp,*) cvarin,' = ',jdmtst
      if (cvarin.ne.'jdm   ') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be jdm   '
        write(lp,*)
        call flush(lp)
        stop
      endif
c
      if (idmtst.ne.idm .or. jdmtst.ne.jdm) then
        write(lp,*)
        write(lp,*) 'error in getdat - input idm,jdm',
     &                        ' not consistent with parameters'
        write(lp,*) 'idm,jdm = ',idm,   jdm,   '  (REGION.h)'
        write(lp,*) 'idm,jdm = ',idmtst,jdmtst,'  (input)'
        write(lp,*)
        call flush(lp)
        stop
      endif
c
c --- read only 'mean' files
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      if     (cline(25:28).eq.'mean' )then
      elseif (cline(25:28).eq.'std.' )then
        write(lp,*)
        write(lp,*) 'error in getdat - ',
     &              'archive is a std. file'
        write(lp,*)
        call flush(lp)
        stop
      else
        write(lp,*)
        write(lp,*) 'error in getdat - ',
     &              'archive is a normal file'
        write(lp,*)
        call flush(lp)
        stop
      endif
      call flush(lp)
c
c --- from mean files, read : 
c ---      mixed layer depth if needed
c ---      velocity and thickness to create momentum fluxes. 
c
c read mix layer depth and skip other surface fields
c skip all surface fields
      if(mxlflg.eq.1) then
        do irec= 1,999
          read (ni,'(a)',end=6) cline
c       write(lp,'(a)')  trim(cline)
          if     (cline(1:8).ne.'mix_dpth') then
            call zaiosk(ni)
          else
            exit
          endif
        enddo
c --- read mixed layer depth
        write(lp,'(a)')    trim(cline)
        i = index(cline,'=')
        read (cline(i+1:),*)  nstep,time,layer,thet,hminb,hmaxb
        if     (cline(1:8).ne.'mix_dpth') then
          write(lp,*)
          write(lp,*) 'error in getdat - layer ',k,
     &               ' does not exist (kk= ',kk,')'
          write(lp,*)
          call flush(lp)
          stop
        endif
        call getfld(dpmixl(1,1), ni, hminb,hmaxb)
        write(6,*)dpmixl(itest,jtest)
        write(lp,'("input  ",a," into ",a,i3)') cline(1:8),'dpmixl '
        call flush(lp)
      endif

      do irec= 1,999
        read (ni,'(a)',end=6) cline
c       write(lp,'(a)')  trim(cline)
        if     (cline(1:8).ne.'u-vel.  ') then
          call zaiosk(ni)
        else
          exit
        endif
      enddo
c
      do k=1,kk
c       write(6,*)'k=',k
c       write(6,*)cline(1:8)
c ---     u-vel cline already input before or at end of loop.
c --- read u-vel, v-vel
        if(k.eq.1.or.k.eq.kk)then
          write(lp,'(a)')    trim(cline)
          call flush(lp)
        endif
        i = index(cline,'=')
        read (cline(i+1:),*)  nstep,time,layer,thet,hminb,hmaxb
        if     (cline(1:8).ne.'u-vel.  ') then
          write(lp,*)
          write(lp,*) 'error in getdat - layer ',k,
     &               ' does not exist (kk= ',kk,')'
          write(lp,*)
          call flush(lp)
          stop
        endif
        call getfld(u(1,1,k), ni, hminb,hmaxb)
        if(k.eq.1.or.k.eq.kk) then
          write(6,*)u(itest,jtest,k)
          write(lp,'("input  ",a," into ",a,i3)') cline(1:8),'u ',k
          call flush(lp)
        endif
         
c ---
        read (ni,'(a)',end=6) cline
        if(k.eq.1.or.k.eq.kk)then
          write(lp,'(a)')    trim(cline)
          call flush(lp)
        endif
        i = index(cline,'=')
        read (cline(i+1:),*)  nstep,time,layer,thet,hminb,hmaxb
        if     (cline(1:8).ne.'v-vel.  ') then
          write(lp,*)
          write(lp,*) 'error in getdat - layer ',k,
     &               ' does not exist (kk= ',kk,')'
          write(lp,*)
          call flush(lp)
          stop
        endif
        call getfld(v(1,1,k), ni, hminb,hmaxb)
        if(k.eq.1.or.k.eq.kk) then
          write(6,*)v(itest,jtest,k)
          write(lp,'("input  ",a," into ",a,i3)') cline(1:8),'v ',k
          call flush(lp)
        endif

c --- skip ke
        read (ni,'(a)',end=6) cline
        i = index(cline,'=')
        if     (cline(1:8).ne.'k.e.    ') then
           write(lp,*) 'error in getdat - no k.e in mean file'
           call flush(lp)
           stop
        endif
        call zaiosk(ni)

c --- read dp

        read (ni,'(a)',end=6) cline
        if(k.eq.1.or.k.eq.kk) then
          write(lp,'(a)')  trim(cline)
          call flush(lp)
        endif
        i = index(cline,'=')
        read (cline(i+1:),*)  nstep,time,layer,thet,hminb,hmaxb
        call getfld(dp(1,1,k), ni, hminb,hmaxb)
        if(k.eq.1.or.k.eq.kk) then
          write(6,*)dp(itest,jtest,k)
          write(lp,'("input  ",a," into ",a,i3)') cline(1:8),'dp',k
          call flush(lp)
        endif
c
c --- skip temp, saln, dens, and other fields
        if(k.lt.kk) then
          do irec= 1,9999
            read (ni,'(a)',end=6) cline
c           write(6,*)cline
            if     (cline(1:8).ne.'u-vel.  ') then
              call zaiosk(ni)
            else
c             write(6,*)cline(1:8),'u-vel.  ', 'found for k=',k+1
              exit
            endif
          enddo
        endif ! if k
      enddo !k

c
      close( unit=14)
      call zaiocl(14)
      return
c
c --- unexpected end of file
 6    continue
        write (lp,*) '***** 2 unexpected end of archive file *****'
        write (lp,*) flnm(1:l-2)//'.b'
        call flush(lp)
        stop '(e-o-f)'
      end

      subroutine getdat_archv(flnm,time, iexpt,yrflag, trcout)
      use mod_tracer  ! HYCOM post-processing tracer archive array interface
      use mod_za      ! HYCOM array I/O interface
c
      implicit none
c
      character        flnm*(*)
      double precision time
      integer          iexpt,yrflag
      logical          trcout  !ignored
c
c --- read model fields for floats.
c --- HYCOM 2.0 array I/O archive file.
c
      character cline*80
      character preambl(5)*79
      character cvarin*6
      real      hminb,hmaxb,thet
      integer   idmtst,irec,iversn,ios,jdmtst,l,layer,ni,nstep
c
      data ni/14/
c
      l = len_trim(flnm)
      open (unit=ni,file=flnm(1:l-2)//'.b',form='formatted',
     &      status='old',action='read')
      call zaiopf(flnm(1:l-2)//'.a','old', ni)
c
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      call flush(lp)
      read( ni,*) iversn,cvarin
      write(lp,*) cvarin,' = ',iversn
      if (cvarin.ne.'iversn') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                          ' but should be iversn'
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) iexpt,cvarin
      write(lp,*) cvarin,' = ',iexpt
      if (cvarin.ne.'iexpt ') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be iexpt '
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) yrflag,cvarin
      write(lp,*) cvarin,' = ',yrflag
      if (cvarin.ne.'yrflag') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be yrflag'
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) idmtst,cvarin
      write(lp,*) cvarin,' = ',idmtst
      if (cvarin.ne.'idm   ') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be idm   '
        write(lp,*)
        call flush(lp)
        stop
      endif
      read( ni,*) jdmtst,cvarin
      write(lp,*) cvarin,' = ',jdmtst
      if (cvarin.ne.'jdm   ') then
        write(lp,*)
        write(lp,*) 'error in getdat - input ',cvarin,
     &                        ' but should be jdm   '
        write(lp,*)
        call flush(lp)
        stop
      endif
c
      if (idmtst.ne.idm .or. jdmtst.ne.jdm) then
        write(lp,*)
        write(lp,*) 'error in getdat - input idm,jdm',
     &                        ' not consistent with parameters'
        write(lp,*) 'idm,jdm = ',idm,   jdm,   '  (REGION.h)'
        write(lp,*) 'idm,jdm = ',idmtst,jdmtst,'  (input)'
        write(lp,*)
        call flush(lp)
        stop
      endif
c
c --- read only 'normal' files
      read( ni,'(a)') cline
      write(lp,'(a)') trim(cline)
      if     (cline(25:28).eq.'mean' .or.
     &        cline(25:28).eq.'std.' )then
        write(lp,*)
        write(lp,*) 'error in getdat - ',
     &              'archive is a mean or std. file'
        write(lp,*)
        call flush(lp)
        stop
      endif
      call flush(lp)
c
c
c --- from normal files, read dp
c
c skip all surface fields
      do irec= 1,9999
        read (ni,'(a)',end=6) cline
c       write(lp,'(a)')  trim(cline)
        if     (cline(1:8).ne.'thknss  ') then
          call zaiosk(ni)
        else
c         write(6,*)cline(1:8), 'thknss  ',' k=1 thknss found'
          exit
        endif
      enddo
c
      do k=1,kk
c       write(6,*)'k=',k
c ---     thknss cline already input before or at end of loop.
c --- read thknss
        if(k.eq.1.or.k.eq.kk) then
          write(lp,'(a)')    trim(cline)
          call flush(lp)
        endif
        i = index(cline,'=')
        read (cline(i+1:),*)  nstep,time,layer,thet,hminb,hmaxb
        if     (cline(1:8).ne.'thknss  ') then
          write(lp,*)
          write(lp,*) 'error in getdat - layer ',k,
     &               ' does not exist (kk= ',kk,')'
          write(lp,*)
          call flush(lp)
          stop
        endif
        call getfld(dp(1,1,k), ni, hminb,hmaxb)
        if(k.eq.1.or.k.eq.kk) then
          write(6,*)dp(itest,jtest,k)
          write(lp,'("input  ",a," into ",a,i3)') cline(1:8),'dp ',k
          call flush(lp)
        endif
c
c --- skip other fields
        if(k.lt.kk) then
          do irec= 1,9999
            read (ni,'(a)',end=6) cline
c           write(6,*)cline
            if     (cline(1:8).ne.'thknss  ') then
              call zaiosk(ni)
            else
c             write(6,*)cline(1:8),'thknss  ', 'found for k=',k+1
              exit
            endif
          enddo
        endif ! if k
      enddo !k

c
      close( unit=14)
      call zaiocl(14)
      return
c
c --- unexpected end of file
 6    continue
        write (lp,*) '***** 2 unexpected end of archive file *****'
        write (lp,*) flnm(1:l-2)//'.b'
        call flush(lp)
        stop '(e-o-f)'
      end


      subroutine getfld(field, iunit, hminb,hmaxb)
      use mod_za ! HYCOM array I/O interface
c
      implicit none
c
      integer iunit
      real    field(idm,jdm), hminb,hmaxb
c
c --- read a single array
c
      integer i,j,mask(idm,jdm)
      real    hmina,hmaxa
c
      call zaiord(field,mask,.false., hmina,hmaxa, iunit)
c
      if     (abs(hmina-hminb).gt.abs(hminb)*1.e-4 .or.
     &        abs(hmaxa-hmaxb).gt.abs(hmaxb)*1.e-4     ) then
        write(lp,'(/ a / a,1p3e14.6 / a,1p3e14.6 /)')
     &    'error - .a and .b files not consistent:',
     &    '.a,.b min = ',hmina,hminb,hmina-hminb,
     &    '.a,.b max = ',hmaxa,hmaxb,hmaxa-hmaxb
        call flush(lp)
        stop
      endif
c
      do j= 1,jdm
        do i= 1,idm
          if     (field(i,j).gt.2.0**99) then
            field(i,j) = 0.0
          endif
        enddo
      enddo
      return
      end
