      program tracers
      use mod_tracer ! HYCOM offline tracer 
      use mod_za     ! HYCOM array I/O interface
c
      implicit none
c
c --- offline tracer  from a sequence of HYCOM 2.0
c --- archive files.
c
c instantaneous and mean archive names
      character*120    flnmi,flnmm  
      logical          lexist,lfatal,trcout
      integer          iexpt,yrflag,ka,l
      real             depthi(0:1,0:1,0:99),duk,dukm1,dvk,dvkm1
      real             dummy
      double precision time_ai,time_ao,timei_ai,timei_ao,time1,time2
      real             eps,time,delt
      real             sumtr,sumdp
      real             q1,q2
      integer          mxlflg
      integer          t1,t2
c
      real amin,amax
      integer imin,jmin,imax,jmax
      integer iord
      integer kmixl
      real, allocatable, dimension (:,:) :: sumhrdv
      call xcspmd
      call zaiost
c
      lp=6
      onecm=0.01*onem
      tencm=0.10*onem
c
      pi = 4.0*atan(1.0)
      radian=pi/180.0
c
c --- 'flnm_ai'  = name of first input archive file
c --- 'flnm_ao'  = name of final input archive file
c --- 'iexpt '   = experiment number x10  (000=from archive file)
c --- 'yrflag'   = days in year flag (0=360J16,1=366J16,2=366J01,3=actual)
c --- 'archfq'   = no. of hours between archive input
c --- 'archin'   = no. of hours between time-interpolated archive input
c --- 'idm   '   = longitudinal array size
c --- 'jdm   '   = latitudinal  array size
c --- 'kdm   '   = number of layers
c
c --- initial and final mean archives
      read(5,*) flnm_ai
      write(6,*)'flnm_ai  ',trim(flnm_ai)
      read(5,*) flnm_ao
      write(6,*)'flnm_ao  ',trim(flnm_ao)
c --- initial and final instantaneous archives
      read(5,*) flnmi_ai
      write(6,*)'flnmi_ai  ',trim(flnmi_ai)
      read(5,*) flnmi_ao
      write(6,*)'flnmi_ao  ',trim(flnmi_ao)
      call blkini(iexpt, 'iexpt ')
      call blkini(yrflag,'yrflag')
      call blkinr(archfq,
     &           'archfq','("blkinr: ",a6," =",f11.4," hours")')
      call blkinr(archin,
     &           'archin','("blkinr: ",a6," =",f11.4," hours")')
      archfq=archfq/24.0
      archin=archin/24.0
      if(archin.gt.archfq) then
      write(6,*)'error, archin can not be greater than archfq'
      stop
      endif
c     nintrp=0
c     if (archfq.ne.archin) then
        nintrp=nint(archfq/archin)
        if (archfq/archin.ne.float(nintrp)) then
          stop 'archfq must be an integer multiple of archin'
        endif
c     endif
      delt=archfq*86400.
      write(6,*)'delt as archfq in seconds', delt
      call blkini(ii,    'idm   ')
      call blkini(jj,    'jdm   ')
      call blkini(kdm,   'kdm   ')
      call blkini(kk,    'kk    ')
      if     (ii.ne.idm .or. jj.ne.jdm) then
        write(lp,*)
        write(lp,*) 'error - wrong idm or jdm (should be:',idm,jdm,')'
        write(lp,*)
        call flush(lp)
        stop 
      endif
c --- 'thbase'   = reference sigma
c --- 'ntracr'   = number of tracers
c --- 'tracin'   = 0: initialze to 0; 1: from restart_tracr_in; 2: from relax.tracer.a,b
c --- 'mxlflg'   = 0 no extra mixing in mixed layer; 1: instantaneous homog of mixed layer.
c --- 'restfq'   tracer restart frequency
c#### not implemented c --- 'trcflg'   = 0 surface tracer
c#####not implememted c --- 'forflg'   = 0 no forcing
c --- 'iord  '   = 1:simple donnor cell; 2: complete with antidiffusive fluxes
c --- 'itest ' = i for printout
c --- 'jtest ' = j for printout
      call blkinr(thbase,
     &           'thbase','("blkinr: ",a6," =",f11.4," days")')
      call blkini(ntracr,'ntracr')
      call blkini(tracin,'tracin')
      call blkini(mxlflg,'mxlflg')
      call blkinr(restfq,
     &           'restfq','("blkinr: ",a6," =",f11.4," hours")')
      restfq=restfq/24.
      call blkini(iord  ,'iord  ')
      call blkini(itest, 'itest ')
      call blkini(jtest, 'jtest ')
c
c --- array allocation
c
      call tracer_alloc
      allocate (sumhrdv(ii,jj))
c
c --- land masks.
c
      call geopar
c
c --- first and last model days from the input archives.
c
      call getdat_time(flnm_ai,time_ai,iexpt)
      write(6,*)'mean initial archive time', time_ai
      call getdat_time(flnm_ao,time_ao,iexpt)
      write(6,*)'mean final archive time', time_ao
      call getdat_time(flnmi_ai,timei_ai,iexpt)
      write(6,*)'intantaneous initial archive time', timei_ai
      call getdat_time(flnmi_ao,timei_ao,iexpt)
      write(6,*)'intantaneous final archive time', timei_ao
      eps=0.002
      if((abs(time_ai-timei_ai-archfq/2)).gt.eps) then
        write(6,*)'error, initial instantaneous and mean 
     &             archive times not consistent'
        stop
      endif
      write(6,*)'time_ao', time_ao
      write(6,*)'timei_ao',timei_ao
      write(6,*)'archfq',archfq
      write(6,*)'time_ao-timei_ao+archfq/2',time_ao-timei_ao+archfq/2
      if((abs(time_ao-timei_ao+archfq/2)).gt.eps) then
        write(6,*)'error, final instantaneous and mean 
     &             archive times not consistent'
        stop
      endif
c
      narch = nint((time_ao-time_ai)/archfq) + 1
c
      write(lp,900) flnm_ai,flnm_ao
  900 format('first and last archives files:'//a120/a120)
      write(lp,910) narch,time_ai,time_ao
  910 format(/'number of archives, start and end times:'/i6,
     &       1p,2e16.8)
c
c --- initialize the tracer to zero or from a restart file
c --- 
      time=time_ai
      write(6,*)'tracer_init'
      call tracer_init(tracin,ntracr,time)
      do ktr=1,ntracr
      write(6,*)'tracer ktr', ktr,itest,jtest
      do k=1,kk
          write(6,'(i3,f8.4)')k, tracer(itest,jtest,k,ktr) 
      enddo
      enddo

      flnmi=flnmi_ai
      flnmm=flnm_ai
c
c --- each time step needs 2 instantaneous archives for delta dp in time, 
c --- and one mean archive
c ---
c --- main loop
c ---
      do iar=1,narch

c --- dpii instantaneous initial dp
c --- dpio instantaneous end of interval dp
c --- read initial instantaneous archive dp and save it in meters
        if(iar.eq.1)then
          time2=timei_ai+(iar-1)*archfq
          call getdat_name(flnmi,time2,yrflag)
          write(lp,'(a,i4,f10.2,/a)') 'iar,time2,flnmi = ',
     &                               iar,time2,flnmi(1:len_trim(flnmi))
          call flush(lp)
          call getdat_archv(flnmi,time2,iexpt,yrflag,trcout)
          do k=1,kdm
            do j=1,jdm
              do i=1,idm
                dpii(i,j,k)=dp(i,j,k)/onem
              enddo
            enddo
          enddo
        endif

c
c ---   end of interval instantaneous archive dp
        time2=timei_ai+(iar)*archfq
        write(6,*)'calling getdat_name'
        call getdat_name(flnmi,time2,yrflag)
        write(lp,'(a,i4,f10.2,/a)') 'iar,time2,flnmi = ',
     &                               iar,time2,flnmi(1:len_trim(flnmi))
        call flush(lp)
        call getdat_archv(flnmi,time2,iexpt,yrflag,trcout)
        do k=1,kdm
          do j=1,jdm
            do i=1,idm
              dpio(i,j,k)=dp(i,j,k)/onem
            enddo
          enddo
        enddo
        write(6,*)'dp instantaneous, dpii,dpio, dpio-dpii,sum dpio-dpii'
        i=itest
        j=jtest
        dummy=0
        do k=1,kk 
          dummy=dummy+dpio(i,j,k)-dpii(i,j,k)
          write(6,'(i3,2f15.3,f15.4,f15.4)')
     &         k,dpii(i,j,k),dpio(i,j,k),dpio(i,j,k)-dpii(i,j,k), 
     &         dummy
        enddo
        write(6,*)'sum deltadp ', dummy
c
c ---   mean archive: read dp,u,v
c ---                 read also dpmixl if homogenization wanted
        time2=time_ai+(iar-1)*archfq
        write(6,*)'calling getdat_name'
        call getdat_name(flnmm,time2,yrflag)
        write(lp,'(a,i4,f10.2,/a)') 'iar,time2,flnmm = ',
     &                               iar,time2,flnmm(1:len_trim(flnmm))
        call flush(lp)
        call getdat_archm(flnmm,time2,iexpt,yrflag,trcout,mxlflg)
c mean dp in meters
        do j=1,jj
          do i=1,ii
            do k=1,kk
              dp(i,j,k)=dp(i,j,k)/onem
            enddo
          enddo
        enddo
c mean mixed layer depth in meters
        if (mxlflg.eq.1) then
          do j=1,jj
            do i=1,ii
              dpmixl(i,j)=dpmixl(i,j)/onem
            enddo
          enddo
        endif
c
c
c --- mean p 
        do j=1,jj
          do l=1,isp(j)
           do i=ifp(j,l),ilp(j,l)
             p(i,j,1)=0
             do k=1,kk
               p(i,j,k+1)=p(i,j,k)+dp(i,j,k)
             enddo
           enddo
          enddo
        enddo
c ---        
        do k=1,kk
        do j=1,jj
          do l=1,isu(j)
           do i=ifu(j,l),ilu(j,l)
             dpu(i,j,k)=min(depthu(i,j),0.5*(p(i,j,k+1)+p(i-1,j,k+1)))-
     &          min(depthu(i,j), 0.5*(p(i,j,k  )+p(i-1,j,k  )))
             enddo
           enddo
        enddo
        do j=1,jj
         do l=1,isv(j)
           do i=ifv(j,l),ilv(j,l)
             dpv(i,j,k)=min(depthv(i,j),0.5*(p(i,j,k+1)+p(i,j-1,k+1)))-
     &              min(depthv(i,j), 0.5*(p(i,j,k  )+p(i,j-1,k  )))
           enddo
         enddo
        enddo
        enddo
        i=itest
        j=jtest
        write(6,*)'k,dpu,dpv calculated from  p',itest,jtest
        do k=1,kk 
          write(6,'(i3,10f10.4)')k,dpu(i,j,k),dpv(i,j,k)
        enddo
c ---
        do j= 1,jj
          do i= 1,ii
            duk           = 0.0
            dvk           = 0.0
            depthi(:,:,0) = 0.0
            do k= 1,kk
              depthi(1,1,k) =
     &        depthi(1,1,k-1) + dp(    i,     j,     k)
              depthi(0,1,k) =
     &        depthi(0,1,k-1) + dp(max(i-1,1),j,     k)
              if(lperiod.and.i.eq.1) then
                depthi(0,1,k) =
     &          depthi(0,1,k-1) + dp(idm,     j,     k)
              endif
              depthi(1,0,k) =
     &        depthi(1,0,k-1) + dp(    i, max(j-1,1),k)
              dukm1 = duk
              duk   = min( depthu(i,j),
     &                     0.5*(depthi(0,1,k) + depthi(1,1,k)) )
              dvkm1 = dvk
              dvk   = min( depthv(i,j),
     &                     0.5*(depthi(1,0,k) + depthi(1,1,k)) )
              dpu(i,j,k) = max( 0.0, duk-dukm1 )
              dpv(i,j,k) = max( 0.0, dvk-dvkm1 )
            enddo !k
          enddo !i
        enddo !j
        call pr_5x5(dpu(1,1,1),ii,jj,itest,jtest,0,1.,'dpu')
        call pr_5x5(dpv(1,1,1),ii,jj,itest,jtest,0,1.,'dpv')
        write(6,*)'dpu,dpv as in transport',itest,jtest
        i=itest
        j=jtest
        do k=1,kk 
          write(6,'(i3,10f10.4)')k,dpu(i,j,k),dpv(i,j,k)
        enddo

c ---   obtain the momentum fluxes 
c uflx,vflx  m3/s * delt = m3
        do k=1,kk
          do j=1,jj
            do i=1,ii
              if(iu(i,j).eq.1) then
                uflx(i,j,k)=u(i,j,k)*dpu(i,j,k)*scuy(i,j)*delt
              else
                uflx(i,j,k)=0.
              endif
              if(iv(i,j).eq.1) then
                vflx(i,j,k)=v(i,j,k)*dpv(i,j,k)*scvx(i,j)*delt
              else
                vflx(i,j,k)=0.
              endif
            enddo
          enddo
        enddo
        write(6,*)'u,dpu,uflx,v,dpv,vflx',itest,jtest
        i=itest
        j=jtest
        do k=1,kk 
          write(6,'(i3,10e13.5)')k,u(i,j,k),dpu(i,j,k),uflx(i,j,k),
     &              v(i,j,k),dpv(i,j,k),vflx(i,j,k)
        enddo
c --- main calculation for tracer advection
c --- interpolate tracer to initial ocean state.
c --- no recast
  

c --- advect the tracer

c     write(6,*)'p itest jtest k=1,kk',(p(itest,jtest,k),k=1,kk)
c --- compute the horizontal divergence, per unit area
c --- hordiv in m3/m2 = m 
        do k=1,kk
          do j=1,jj-1
            do i=1,ii
              if(lperiod) then
                i1=mod(i,ii)+1
              else
                i1=min(i+1,ii)
              endif
              if(ip(i,j).eq.1) then
                hordiv(i,j,k)=(uflx(i1,j,k)-uflx(i,j,k)
     &                     +vflx(i,j+1,k)-vflx(i,j,k))
                hordiv(i,j,k)=hordiv(i,j,k)*scp2i(i,j)
              endif
            enddo
          enddo
        enddo
      write(6,*)'hordiv ',itest,jtest
      do k=1,kk
      write(6,'(i3,e13.5)')k,hordiv(itest,jtest,k)
      enddo
      do j=1,jj
       do i=1,ii
          sumhrdv(i,j)=0
          do k=1,kk
            sumhrdv(i,j)=sumhrdv(i,j)+hordiv(i,j,k)
          enddo
        enddo
      enddo
      write(6,*)'amin and max of sum of horizontal divergence'
      call aminmax(ip,sumhrdv,ii,jj,amin,amax,imin,jmin,imax,jmax,
     .      -1.e40)
c --- compute vertical divergence and dia-hybrid flux, for the archive save interval, delt
c --- units m
        do j=1,jj
          do i=1,ii
            if(ip(i,j).eq.1) then
              diaflx(i,j,1)=0
              do k=1,kk
                ka=max(1,k-1)
                vertdiv=dpii(i,j,k)-dpio(i,j,k)-hordiv(i,j,k)
                diaflx(i,j,k)=diaflx(i,j,ka)+vertdiv
c ---  if diaflx(i,j,kk).ne.0: 
c ---  expand or contract dpii to avoid mass gain/loss through bottom : left for later
              enddo
            endif
          enddo
        enddo
       i=itest
       j=jtest
       write(6,*)'k hordiv, vertdiv diaflx',itest,jtest
       do k=1,kk
       write(6,'(i3,10e13.5)')k, hordiv(i,j,k),
     .           dpii(i,j,k)-dpio(i,j,k)-hordiv(i,j,k),
     .           diaflx(i,j,k)
       enddo
       write(6,*)'diaflx kk, accum on delt' ,diaflx(itest,jtest,kk),delt
     .            
c       
c     if (nintrp.lt.1) then
c
c --- no temporal interpolation. User has to make sure that CFL is not violated.
c --- 3-d tracer advection, fct2 
c --- call with first argument 2: fct2; 1: simple donnor cell
c       do ktr=1,ntracr
c         call fct3d(iord,tracer(1,1,1,ktr),uflx,vflx,diaflx,
c    &             scp2,scp2i,dpii,dpio)
c         if (mxlflg.eq.1) then
c homogenize the mixed layer tracer
c --- last layer in mixed layer. p of mean archive already computed
c           do j=1,jj
c             do l=1,isp(j)
c              do i=ifp(j,l),ilp(j,l)
c                do k=1,kk
c                  if (p(i,j,k+1).gt.dpmixl(i,j)) then
c                  kmixl=k
c                  exit
c                  endif
c                enddo !k
c                if(i.eq.itest.and.j.eq.jtest) then
c                  write(6,*)'i,j,mixed layer depth, k mixed layer',
c    &             itest,jtest,dpmixl(itest,jtest),kmixl
c                endif
c                sumtr=0
c                sumdp=0
c                do k=1,kmixl
c                  sumtr=sumtr+tracer(i,j,k,ktr)*dp(i,j,k)
c                  sumdp=sumdp+dp(i,j,k)
c                  if(i.eq.itest.and.j.eq.jtest) then
c                    write(6,*)'i,j,k,sumtr,sumdp',i,j,k,sumtr,sumdp
c                  endif
c                enddo
c                do k=1,kmixl
c sumdp >1m 
c                  if (sumdp.gt.1 ) then
c                    if(i.eq.itest.and.j.eq.jtest) then
c                      write(6,*)tracer(i,j,k,ktr),sumtr*dp(i,j,k)/sumdp
c                      tracer(i,j,k,ktr)=sumtr/sumdp
c                    endif
c                  endif
c                enddo !k
c              enddo
c             enddo
c           enddo
c         endif !mxlflg
c --- adjst tracer for earlier manipulation of dpfin1: not done for now
c       enddo   ! ktr
c 
c     else
c
c --- if nintrp >1, interpolate fluxes and dp to smaller time steps,or if =1 get default result
c
        write(6,*)'nintrp',nintrp
        do n=1,nintrp
          q1=float(n-1)/float(nintrp)
          q2=float(n)  /float(nintrp)
          write(6,*)'n, q1,q2', n,q1,q2
          do j=1,jj
            do l=1,isp(j)
              do i=ifp(j,l),ilp(j,l)
                do k=1,kk
                  uflxi(i,j,k)  = uflx(i,j,k)  /float(nintrp)
                  vflxi(i,j,k)  = vflx(i,j,k)  /float(nintrp)
                  diaflxi(i,j,k)= diaflx(i,j,k)/float(nintrp)
                  dp1(i,j,k)    = dpii(i,j,k)*(1.-q1)+dpio(i,j,k)*q1   
                  dp2(i,j,k)    = dpii(i,j,k)*(1.-q2)+dpio(i,j,k)*q2   
                enddo
              enddo
            enddo
          enddo
          do ktr=1,ntracr
            call fct3d(iord,tracer(1,1,1,ktr),uflxi,vflxi,diaflxi,
     &                scp2,scp2i,dp1,dp2)
c --- 
            if (mxlflg.eq.1) then
c homogenize the mixed layer tracer
c --- last layer in mixed layer. p of mean archive already computed
              do j=1,jj
                do l=1,isp(j)
                 do i=ifp(j,l),ilp(j,l)
                   do k=1,kk
                     if (p(i,j,k+1).gt.dpmixl(i,j)) then
                     kmixl=k
                     exit
                     endif
                   enddo !k
                   if(i.eq.itest.and.j.eq.jtest) then
                     write(6,*)'i,j,mix layer depth, k mixed layer',
     &               itest,jtest,dpmixl(itest,jtest),kmixl
                   endif
                   sumtr=0
                   sumdp=0
                   do k=1,kmixl
                     sumtr=sumtr+tracer(i,j,k,ktr)*dp(i,j,k)
                     sumdp=sumdp+dp(i,j,k)
                     if(i.eq.itest.and.j.eq.jtest) then
                       write(6,*)'i,j,k,sumtr,sumdp',i,j,k,sumtr,sumdp
                     endif
                   enddo
                   do k=1,kmixl
c sumdp >1m 
                     if (sumdp.gt.1 ) then
                       if(i.eq.itest.and.j.eq.jtest) then
                         write(6,*)tracer(i,j,k,ktr),
     &                     sumtr*dp(i,j,k)/sumdp,sumtr/sumdp
                       endif
                       tracer(i,j,k,ktr)=sumtr/sumdp
                     endif
                   enddo !k
                 enddo !i
                enddo !l
              enddo !j
            endif !mxlflg
c --- adjst tracer for earlier manipulation of dpfin1: not done for now
          enddo   ! ktr
        enddo !nintrp

c     endif !nintrp.lt.1

      write(6,*)'dpii-dpio, tracer after fct3d  nintrp times ',
     &  itest,jtest,max(1,nintrp)
      ktr=1
      do k=1,kk
      write(6,'(i3,2f10.5)')k,
     & dpii(itest,jtest,k)-dpio(itest,jtest,k),tracer(itest,jtest,k,ktr)
      enddo
c
c --- at the end of the time step move dpio to dpii
        do k=1,kdm
          do j=1,jdm
            do i=1,idm
              dpii(i,j,k)=dpio(i,j,k)
            enddo
          enddo
        enddo
      if(restfq.gt.0) then
        time2=timei_ai+(iar)*archfq
        write(6,*)'calling getdat_name'
        call getdat_name(flnmi,time2,yrflag)
        write(lp,'(a,i4,f10.2,/a)') 'iar,time2,flnmi = ',
     &                    iar,time2,flnmi(1:len_trim(flnmi))
        write(6,*)flnmi
        flnm_o='restart_out_'//flnmi(11:21)
        write(6,('(a)') )flnm_o
        write(6,*)'time2/restfq-nint(time2/restfq)',
     .           time2/restfq-nint(time2/restfq)
        t1=iar
        t2=restfq
        write(6,*)'restart output?', t1,t2,mod(t1,t2)
        if(mod(t1,t2).eq.0)
     .   call tracer_restart(time2,flnm_o)
      endif
      enddo  ! iar
      time1=time2
      time2=timei_ai+narch*archfq
      if((time2-time1).gt.02)then
      write(6,*)'time1,time2',time2
      call getdat_name(flnm_o,time2,yrflag)
      write(6,*)flnm_o
      flnm_o='restart_out_'//flnm_o(11:21)
      write(6,*)flnm_o
      call tracer_restart(time1,flnm_o)
      endif
c
c
      stop
c
      end
      subroutine pr_5x5(array,idm,jdm,iz,jz,offset,scale,what)
c
c --- (sames as prt9x9 except that array dimensions are passed as arguments)
c
c --- write 5 x 5 point cluster of 'array' values centered on (iz,jz).
c --- the printed numbers actually represent (array(i,j) + offset) * scale
c
      implicit none
      integer,intent(IN) :: idm,jdm,iz,jz
      real   ,intent(IN) :: array(idm,jdm),scale,offset
      character what*(*),text*12
      integer i,j,jwrap
 100  format(a12,5i13)
 101  format(i10,3x,5f13.5)
c
      text='            '
      text(1:min(12,len_trim(what)))=what(1:min(12,len_trim(what)))
      write (*,100) text,(i,i= iz-2,iz+2)
      write (*,101) (j,(scale*(array(i,j)+offset),
     . i=iz-2,iz+2),j=jz+2,jz-2,-1)
      return
      end
      subroutine aminmax(ip,array,idm,jdm,amin,amax,imin,jmin,imax,
     .                   jmax,spval)
      implicit none
      real array,amin,amax,spval
      integer ip, idm,jdm,imin,jmin,imax,jmax,i,j
      dimension array(idm,jdm),ip(idm,jdm)
      amin=1.e40
      amax=-1.e40 
      do j=1,jdm
        do i=1,idm
          if(ip(i,j).eq.1) then
            if(array(i,j).lt.amin.and.array(i,j).ne.spval) then
              amin=array(i,j)
              imin=i
              jmin=j
            endif
            if(array(i,j).gt.amax.and.array(i,j).ne.spval) then
              amax=array(i,j)
              imax=i
              jmax=j
            endif
          endif
        enddo
      enddo
      write(6,*)'min,max', amin,imin,jmin, amax,imax,jmax
      return
      end
